/*
 * Copyright 2017-2020 NXP
 * All rights reserved.
 *
 *
 * SPDX-License-Identifier: BSD-3-Clause
 *
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PIN_MUX_H_
#define _PIN_MUX_H_

/*!
 * @addtogroup pin_mux
 * @{
 */

/***********************************************************************************************************************
 * API
 **********************************************************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif

/* Define the PIO[ANAMODE] bit macro (SDK 2.6.x and older miss this bit macro definition) */
#ifndef IOCON_PIO_ANAMODE_MASK
#define IOCON_PIO_ANAMODE_MASK  (0x40U)
#define IOCON_PIO_ANAMODE_SHIFT (6U)
#define IOCON_PIO_ANAMODE(x)    (((uint32_t)(((uint32_t)(x)) << IOCON_PIO_ANAMODE_SHIFT)) & IOCON_PIO_ANAMODE_MASK)
#endif

/*!
 * @brief Calls initialization functions.
 *
 */
void BOARD_InitBootPins(void);

/*!
 * @brief Enables or disables analog mode.: Disable analog Mode. */
#define PIO010_ANAMODE_DISABLED 0x01u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO010_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 6. */
#define PIO010_FUNC_ALT6 0x06u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO010_MODE_INACTIVE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO029_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO029_FUNC_ALT1 0x01u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO029_MODE_INACTIVE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO030_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO030_FUNC_ALT1 0x01u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO030_MODE_INACTIVE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO22_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 0. */
#define PIO22_FUNC_ALT0 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO314_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 0. */
#define PIO314_FUNC_ALT0 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO323_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO323_FUNC_ALT1 0x01u
/*!
 * @brief
 * Controls the current sink capability of the pin.
 * : High drive.
 * Output drive sink is 20 mA.
 * This is needed for Fast Mode Plus I 2C.
 * Refer to the appropriate specific device data sheet for details.
 */
#define PIO323_I2CDRIVE_HIGH 0x01u
/*!
 * @brief
 * Configures I2C features for standard mode, fast mode, and Fast Mode Plus operation.
 * : Disabled.
 * I2C 50 ns glitch filter disabled.
 */
#define PIO323_I2CFILTEROFF_DISABLED 0x01u
/*!
 * @brief Controls slew rate of I2C pad.: I2C mode. */
#define PIO323_I2CSLEW_I2C_MODE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO324_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO324_FUNC_ALT1 0x01u
/*!
 * @brief
 * Controls the current sink capability of the pin.
 * : High drive.
 * Output drive sink is 20 mA.
 * This is needed for Fast Mode Plus I 2C.
 * Refer to the appropriate specific device data sheet for details.
 */
#define PIO324_I2CDRIVE_HIGH 0x01u
/*!
 * @brief
 * Configures I2C features for standard mode, fast mode, and Fast Mode Plus operation.
 * : Disabled.
 * I2C 50 ns glitch filter disabled.
 */
#define PIO324_I2CFILTEROFF_DISABLED 0x01u
/*!
 * @brief Controls slew rate of I2C pad.: I2C mode. */
#define PIO324_I2CSLEW_I2C_MODE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO33_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 0. */
#define PIO33_FUNC_ALT0 0x00u

/*! @name PIO3_14 (coord E3), LED1
  @{ */
#define BOARD_INITPINS_LED1_GPIO GPIO /*!<@brief GPIO device name: GPIO */
#define BOARD_INITPINS_LED1_PORT 3U   /*!<@brief PORT device name: 3U */
#define BOARD_INITPINS_LED1_PIN 14U   /*!<@brief 3U pin index: 14 */
                                      /* @} */

/*! @name PIO3_3 (coord A13), LED2
  @{ */
#define BOARD_INITPINS_LED2_GPIO GPIO /*!<@brief GPIO device name: GPIO */
#define BOARD_INITPINS_LED2_PORT 3U   /*!<@brief PORT device name: 3U */
#define BOARD_INITPINS_LED2_PIN 3U    /*!<@brief 3U pin index: 3 */
                                      /* @} */

/*! @name PIO2_2 (coord C3), LED3
  @{ */
#define BOARD_INITPINS_LED3_GPIO GPIO /*!<@brief GPIO device name: GPIO */
#define BOARD_INITPINS_LED3_PORT 2U   /*!<@brief PORT device name: 2U */
#define BOARD_INITPINS_LED3_PIN 2U    /*!<@brief 2U pin index: 2 */
                                      /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitPins(void); /* Function assigned for the Cortex-M4F */

/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO017_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 7. */
#define PIO017_FUNC_ALT7 0x07u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO017_MODE_INACTIVE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO226_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 0. */
#define PIO226_FUNC_ALT0 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO410_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO410_FUNC_ALT1 0x01u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO410_MODE_INACTIVE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO411_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO411_FUNC_ALT1 0x01u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO411_MODE_INACTIVE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO412_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO412_FUNC_ALT1 0x01u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO412_MODE_INACTIVE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO413_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO413_FUNC_ALT1 0x01u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO413_MODE_INACTIVE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO414_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO414_FUNC_ALT1 0x01u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO414_MODE_INACTIVE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO415_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO415_FUNC_ALT1 0x01u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO415_MODE_INACTIVE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO416_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO416_FUNC_ALT1 0x01u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO416_MODE_INACTIVE 0x00u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO48_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 1. */
#define PIO48_FUNC_ALT1 0x01u
/*!
 * @brief
 * Selects function mode (on-chip pull-up/pull-down resistor control).
 * : Inactive.
 * Inactive (no pull-down/pull-up resistor enabled).
 */
#define PIO48_MODE_INACTIVE 0x00u

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitEnet(void); /* Function assigned for the Cortex-M4F */

/*!
 * @brief Enables or disables analog mode.: Disable analog Mode. */
#define PIO023_ANAMODE_DISABLED 0x01u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO023_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 6. */
#define PIO023_FUNC_ALT6 0x06u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO024_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 6. */
#define PIO024_FUNC_ALT6 0x06u
/*!
 * @brief
 * Driver slew rate.
 * : Fast mode, slew rate control is disabled.
 * Refer to the appropriate specific device data sheet for details.
 */
#define PIO024_SLEW_FAST 0x01u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO025_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 6. */
#define PIO025_FUNC_ALT6 0x06u
/*!
 * @brief
 * Driver slew rate.
 * : Fast mode, slew rate control is disabled.
 * Refer to the appropriate specific device data sheet for details.
 */
#define PIO025_SLEW_FAST 0x01u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO026_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 6. */
#define PIO026_FUNC_ALT6 0x06u
/*!
 * @brief
 * Driver slew rate.
 * : Fast mode, slew rate control is disabled.
 * Refer to the appropriate specific device data sheet for details.
 */
#define PIO026_SLEW_FAST 0x01u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO027_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 6. */
#define PIO027_FUNC_ALT6 0x06u
/*!
 * @brief Select Analog/Digital mode.: Digital mode. */
#define PIO028_DIGIMODE_DIGITAL 0x01u
/*!
 * @brief Selects pin function.: Alternative connection 6. */
#define PIO028_FUNC_ALT6 0x06u
/*!
 * @brief
 * Driver slew rate.
 * : Fast mode, slew rate control is disabled.
 * Refer to the appropriate specific device data sheet for details.
 */
#define PIO028_SLEW_FAST 0x01u

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitSPIFI(void); /* Function assigned for the Cortex-M4F */

#if defined(__cplusplus)
}
#endif

/*!
 * @}
 */
#endif /* _PIN_MUX_H_ */

/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
